"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Sample(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "labSampleId",
        "sampleId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3

        return {
            "preparationMethod": participant_1_0_3.PreparationMethod,
            "product": participant_1_0_3.Product,
            "source": participant_1_0_3.SampleSource,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3

        return {
            "org.gel.models.participant.avro.PreparationMethod": participant_1_0_3.PreparationMethod,
            "org.gel.models.participant.avro.Product": participant_1_0_3.Product,
            "org.gel.models.participant.avro.SampleSource": participant_1_0_3.SampleSource,
            "org.gel.models.participant.avro.Sample": participant_1_0_3.Sample,
        }

    __slots__ = [
        "labSampleId",
        "sampleId",
        "preparationMethod",
        "product",
        "source",
    ]

    def __init__(
        self,
        labSampleId,
        sampleId,
        preparationMethod=None,
        product=None,
        source=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_0_3.Sample model.

        :param labSampleId:
            Lab Sample Id
        :type labSampleId: int
        :param sampleId:
            Sample Id (e.g, LP00012645_5GH))
        :type sampleId: str
        :param preparationMethod:
            preparationMethod
        :type preparationMethod: None | PreparationMethod
        :param product:
            Product
        :type product: None | Product
        :param source:
            Source
        :type source: None | SampleSource
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.3"
